<template>
	<div>

        <div class="cg-profile-over-view-wrap">
            <div class="d-flex align-items-center justify-content-center cg-common-banner-text">
                <h2 v-if="product_category_.sub_title_1">{{ product_category_.sub_title_1 }}</h2>
                <p v-if="product_category_.sub_title_2">{{ product_category_.sub_title_2 }}</p>
                <h2 v-if="!product_category_.sub_title_1">Hey, here are the top quality creative assets suitable for you.</h2>
                <p v-if="!product_category_.sub_title_2">Let's make your project more attractive by choosing Fontfolio.</p>
            </div>
            <div class="cg-shop-extras-wrap">
                <div class="container">
                    <div class="row d-flex justify-content-between align-items-center">
                        <div class="cg-shop-filter-btn-wrap">
                            <a class="cg-shop-filter-btn second-bg" href="#">Show Filter<span></span></a>
                        </div>
                        <div class="cg-shop-search-wrap">
                            <input class="font1 cg-home-search-input-section second w600 add-btm-xsml" id="search_key" name="search" v-model="key_word_" @keyup.enter="trigger" placeholder="Search here" data-placeholder="Search">
                            <a href="#" @click="fetchProducts()" ref="triggerEnter"><i class="cg-shop-search-ico fas fa-search grey"></i></a>
                        </div>
                        <div class="cg-shop-sort-btn-wrap">

                            <select class="first theme-bg w500 f13"  v-model="sort_by" @change="fetchProducts()">
                                <option value="popular" selected >Popular</option>
                                <option value="price_low">Price Lowest</option>
                                <option value="price_high">Price Highest</option>
                                <option value="new_arrival">New Arrivals</option>
                            </select>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <section class="cg-shop-page-wrap">
            <div class="container">
                <div class="cg-container" >
 <div class="row">
     <div class="col-md-3" id="shopfilter">
         <div class="cg-shop-filter-main">
             <div class="cg-shop-filter-wrap d-flex flex-column">

                 <div class="cg-shop-filter-root add-btm-mdm">
                     <h4 class="font1 f12 second w600"><a href="/all-items"> All Items</a></h4>
                 </div>


                 <div class="cg-shop-filter-sort add-btm-mdm">
                     <label class="f13 w600 grey">Sort by</label>
                     <select id="cg-shop-sortby" class="w500 f13" v-model="sort_by" @change="fetchProducts()">
                         <option value="popular" selected >Popular</option>
                         <option value="price_low">Price Lowest</option>
                         <option value="price_high">Price Highest</option>
                         <option value="new_arrival">New Arrivals</option>
                     </select>
                 </div>

                 <div class="cg-shop-filter-categories add-btm-xl" v-if="product_categories_.length">
                     <h2 class="font1 f14 grey w600 cg-section-sml-heading">Categories</h2>
                     <ul>
                         <li class="d-flex align-items-center" v-for="product_category in product_categories_">
                             <label class="cg-radio-btn" :for="'cat'+ product_category.id +'s'"> {{ product_category.name }}
                             <input type="radio" name="product_categories" :id="'cat'+ product_category.id +'s'" :value="product_category.slug" v-model="category_slug_"  @change="fetchProductSubCategory()">
                                 <span class="checkmark"></span>
                             </label>
                         </li>
                     </ul>

                 </div>

                 <div class="cg-shop-filter-categories add-btm-xl" v-if="product_sub_categories_.length">
                     <h2 class="font1 f14 grey w600 cg-section-sml-heading">Sub Categories</h2>
                     <ul>
                         <li class="d-flex align-items-center" v-for="product_sub_category in product_sub_categories_">
                             <label class="cg-shop-filter-check" :for="'sub'+ product_sub_category.id +'s'"> {{ product_sub_category.name }}
                             <input type="checkbox" :id="'sub'+ product_sub_category.id +'s'" :value="product_sub_category.id" v-model="product_sub_category_ids"  @change="fetchProducts()">
                                 <span class="checkmark"></span>
                             </label>
                         </li>
                     </ul>
                 </div>




                 <div class="cg-shop-filter-categories add-btm-xl" v-if="properties_ && properties_.length">
                     <a class="cg-shop-collapse"  v-if="product_sub_categories_.length" type="button" data-toggle="collapse" data-target="#drop-cg-shop-property" aria-expanded="false" aria-controls="collapseExample">
                         <h2 class="font1 f14 grey w600 cg-section-sml-heading cg-shop-featues-accod">Properties
                             <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="#000" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-chevron-down"><polyline points="6 9 12 15 18 9"></polyline></svg>
                         </h2>

                     </a>
                     <div class="collapse" id="drop-cg-shop-property">
                     <ul>
                         <li class="d-flex align-items-center" v-for="property in properties_">
                             <label class="cg-shop-filter-check" :for="'sub'+ property.id +'p'"> {{ property.name }}
                             <input type="checkbox" :id="'sub'+ property.id +'p'" :value="property.id" v-model="properties"  @change="fetchProducts()">
                             <span class="checkmark"></span>
                             </label>
                         </li>
                     </ul>
                     </div>
                 </div>

                 <div class="cg-shop-filter-categories add-btm-xl" v-if="file_types_ && file_types_.length">
                     <a class="cg-shop-collapse"  v-if="product_sub_categories_.length" type="button" data-toggle="collapse" data-target="#drop-cg-shop-file_type" aria-expanded="false" aria-controls="collapseExample">
                         <h2 class="font1 f14 grey w600 cg-section-sml-heading cg-shop-featues-accod">File Types
                             <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="#000" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-chevron-down"><polyline points="6 9 12 15 18 9"></polyline></svg>
                         </h2>

                     </a>
                     <div class="collapse" id="drop-cg-shop-file_type">
                     <ul>
                         <li class="d-flex align-items-center" v-for="file_type in file_types_">
                             <label class="cg-shop-filter-check" :for="'sub'+ file_type.id +'f'"> {{ file_type.name }}
                             <input type="checkbox" :id="'sub'+ file_type.id +'f'" :value="file_type.id" v-model="file_types"  @change="fetchProducts()">
                                 <span class="checkmark"></span>
                             </label>
                         </li>
                     </ul>
                     </div>
                 </div>

                 <div class="cg-shop-filter-categories add-btm-xl" v-if="application_supports_ && application_supports_.length" >
                     <a class="cg-shop-collapse"  v-if="product_sub_categories_.length" type="button" data-toggle="collapse" data-target="#drop-cg-shop-application_support" aria-expanded="false" aria-controls="collapseExample">
                         <h2 class="font1 f14 grey w600 cg-section-sml-heading cg-shop-featues-accod">Application Supports
                             <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="#000" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-chevron-down"><polyline points="6 9 12 15 18 9"></polyline></svg>
                         </h2>


                     </a>
                     <div class="collapse" id="drop-cg-shop-application_support">
                     <ul>
                         <li class="d-flex align-items-center" v-for="application_support in application_supports_">
                             <label class="cg-shop-filter-check" :for="'sub'+ application_support.id +'a'"> {{ application_support.name }}
                                 <input type="checkbox" :id="'sub'+ application_support.id +'a'" :value="application_support.id" v-model="application_supports"  @change="fetchProducts()">
                                 <span class="checkmark"></span>
                             </label>
                         </li>
                     </ul>
                     </div>
                 </div>


                 <div class="cg-shop-filter-rating">
                     <h2 class="font1 f14 grey w600 cg-section-sml-heading">Product Rating</h2>
                     <!-- <div class="cg-product-star-rating">
                        <i class="f13 theme fa fa-star"></i>
                         <i class="f13 theme fa fa-star"></i>
                         <i class="f13 theme fa fa-star"></i>
                         <i class="f13 theme fa fa-star"></i>
                         <i class="f13 theme fa fa-star"></i>
                     </div> -->
                     <input type="radio" name="stars" v-model="star_rating" value="0" id="star-null" @change="fetchProducts()" hidden="">
                     <input type="radio" name="stars" v-model="star_rating" value="1" id="star-1" @change="fetchProducts()" hidden="">
                     <input type="radio" name="stars" v-model="star_rating" value="2" id="star-2" @change="fetchProducts()" hidden="">
                     <input type="radio" name="stars" v-model="star_rating" value="3" id="star-3" @change="fetchProducts()" checked hidden="">
                     <input type="radio" name="stars" v-model="star_rating" value="4" id="star-4" @change="fetchProducts()" hidden="">
                     <input type="radio" name="stars" v-model="star_rating" value="5" id="star-5" @change="fetchProducts()" hidden="">

                     <div class="strwrap">
                         <label for="star-1">
                              <svg class="f13 feather feather-star" xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg>
                         </label>
                         <label for="star-2">
                             <svg class="f13 feather feather-star" xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg>
                         </label>
                         <label for="star-3">
                             <svg class="f13 feather feather-star" xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg>
                         </label>
                         <label for="star-4">
                             <svg class="f13 feather feather-star" xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg>
                         </label>
                         <label for="star-5">
                             <svg class="f13 feather feather-star" xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg>
                         </label>
                         <label for="star-null"> Clear </label>
                     </div>
                     <div>

                     </div>
                 </div>
             </div>
         </div>


     </div>
     <div class="mini-block-resizer col-md-9" id="shop-products">
	<div class="row d-flex align-items-center justify-content-start">
        <div class="cg-empty-wrap" v-if="!products_.length">
            <div class="cg-empty-content-wrap text-center add-btm-mdm">
                <img src="/images/no-items.svg" alt="creativegoods" class="img-ﬂuid width-30">
                <h4 class="font1 grey f18 w500 pad-top-mdm pad-btm-xsml">Unfortunately, we can't find it.</h4>

            </div>
        </div>
        <div class="col-md-4" v-for="product in products_">
            <div class="cg-featured-item-wrap first-bg">
                <a :href="product.product_url" class="cg-featured-item-achor">
                    <img class="product-thumb img-fluid" v-lazy="product.cover_photo_path"  :alt="product.name">
                </a>
                <div class="cg-card-text-wrap">
                    <a :href="product.product_url">

                        <div class="cg-price-bubble justify-content-center align-items-center">
                            <h3 class="cg-product-price first w600 font1"><span v-if="product.price">${{ product.price }}</span><span v-if="!product.price">Free</span></h3>
                        </div>
                        <h4 class="cg-product-name second font1 f100p w700 pad-top-sml pad-left-mdm">{{ product.name | subStrName }}</h4>
                    </a>
                    <div class="cg-store-in-category">
                    <a :href="product.author.profile_url">
                        <h6 class="cg-account-name f14 light-grey pad-left-mdm pad-btm-mdm">{{ product.author.user_profile.store_name | subStrStore }}</h6>
                    </a>
                    <a>
                        <h6 class="cg-account-name f14 light-grey pad-left-mdm pad-btm-mdm">in </h6>
                    </a>

                    <a :href="product.product_sub_category.product_sub_category_url">
                        <h6 class="cg-account-name f14 light-grey pad-left-mdm pad-btm-mdm">{{ product.product_sub_category.name }}</h6>
                    </a>
                    </div>
                </div>
            </div>
        </div>
    </div>

     </div>

    </div>
        <ShopPagination v-if="pagination.last_page > 1" :pagination="pagination" :offset="5" @paginate="fetchProducts()" ></ShopPagination>


    </div>
    </div>
    </section>

    </div>
</template>

<script>
    import Preloader from '../components/Preloader.vue';
    import ShopPagination from '../components/ShopPagination.vue'
    export default {
        props: ['category_slug', 'sub_category_slug', 'product_sub_categories', 'sub_category_id', 'product_categories', 'product_category', 'key_word', 'price_type'],
        data() {
            return {
                category_slug_:this.category_slug,
                sub_category_slug_:this.sub_category_slug,
                products_:{},
                product_sub_categories_ : JSON.parse(this.product_sub_categories),
                product_categories_ : JSON.parse(this.product_categories),
                product_category_ : JSON.parse(this.product_category),
                star_rating : '',
                sort_by : 'popular',
                product_sub_category_ids : [],
                sub_category_id_:this.sub_category_id,
                product_category_id:'',
                properties_:[],
                file_types_:[],
                application_supports_:[],
                properties:[],
                file_types:[],
                application_supports:[],
                key_word_:this.key_word,
                price_type_:this.price_type,
                loading:true,
                pagination: {
                    'current_page': 1
                },
            }
        },
        components:{
            ShopPagination
        },
        methods: {

            loadJs(url, callback) {
                jQuery.ajax({
                    url: url,
                    dataType: 'script',
                    success: callback,
                    async: true
                });
            },

            fetchProducts() {
                this.preLoad();
                axios.get('/get_shop_products' +
                    '?page=' + this.pagination.current_page +
                    '&category_slug=' + this.category_slug_ +
                    '&sub_category_slug=' + this.sub_category_slug_ +
                    '&star_rating=' + this.star_rating +
                    '&sort_by=' + this.sort_by +
                    '&key_word=' + this.key_word_ +
                    '&price_type=' + this.price_type_ +
                    '&product_sub_category_ids=' + JSON.stringify(this.product_sub_category_ids)+
                    '&properties=' + JSON.stringify(this.properties)+
                    '&file_types=' + JSON.stringify(this.file_types)+
                    '&application_supports=' + JSON.stringify(this.application_supports))

                    .then(response => {
                        this.products_ = response.data.data.data;
                        this.pagination = response.data.pagination;
                    })
                    .catch(error => {
                        console.log(error.response.data);
                    });
            },
            fetchProductSubCategory() {

                    this.product_sub_category_ids=[];
                    this.properties=[];
                    this.file_types=[];
                    this.application_supports=[];
                    this.sub_category_slug_ = '';
                    this.star_rating = 0;

                axios.get('/get_shop_product_sub_categories' +

                    '?category_slug=' + this.category_slug_)
                    .then(response => {

                        this.product_category_ = response.data;
                        this.product_sub_categories_ = this.product_category_.product_sub_categories
                        this.properties_ = this.product_category_.properties
                        this.file_types_ = this.product_category_.file_types
                        this.application_supports_ = this.product_category_.application_supports
                        this.fetchProducts();
                    })
                    .catch(error => {
                        console.log(error.response.data);
                    });
            },

            trigger () {
                this.$refs.triggerEnter.click()
            },
            preLoad: function(){
                // just open
                const close = this.$preloaders.open({
                    container: ".mini-block-resizer",
                    component:Preloader,
                    // cssClass: 'test' ,
                    "overlayStyle": {
                        "backgroundColor": "#fff",
                        "opacity": .1,
                    }

                    // assetStyle: {
                    //   width: "100px",
                    //   height:"400px",
                    // },
                    // overlayStyle: {
                    //   backgroundColor: "#4bc5b3",
                    //   opacity: 1
                    // }
                });

                // and close. That's it.
                setTimeout(close, 1500);
            }
        },
        filters: {

            subStrName: function(string)
            {
               if(string.length >25)
               {
                   return string.substring(0,22) + '...';
               }
               else
               {
                   return string.substring(0,25);
               }
            },

            subStrStore: function(string)
            {
                if(string.length >26)
                {
                    return string.substring(0,23) + '...';
                }
                else
                {
                    return string.substring(0,23);
                }
            }

            },
        mounted() {

            this.star_rating=0;
            this.properties_=this.product_category_.properties;
            this.file_types_=this.product_category_.file_types;
            this.application_supports_=this.product_category_.application_supports;
            if(this.sub_category_id_ !=0)
            {
                this.product_sub_category_ids.push(parseInt(this.sub_category_id_))
            }
            else
            {
                for (let i=0; i<this.product_sub_categories_.length; i++)
                {
                    this.product_sub_category_ids.push(this.product_sub_categories_[i].id)
                }
            }

            this.fetchProducts();

        },
        created(){
            setTimeout(() => {
                this.loading = false;
            },1000);
        },
    }
</script>
